%----------------------------------------------------------------
% 1. Declaration
%----------------------------------------------------------------

var P_p,P_t,theta_p,theta_t,R_p,R_t,S,q_p,q_t,phii,                                //Endogenous variables 
    J_p_s,J_p_ns,J_p0_ns,J_t,J_t_1,W_p_s,W_p_ns,W_t,U,U_p,U_t,V_p,V_t,  //Value function
    w_p_s,w_p_ns,w_p0_ns,w_t,w_t_1,u_p,d,u_t,e_p,e_t,y_p,y_t,w_total,w_total_p,w_total_t,
    x_p_s,x_p_ns,x_t;             //Wage,labor and production

varexo A;

parameters k_p,k_t,tau_p,tau_t,beta_p,beta_t,gamma_p,gamma_t,z,V_p_ss,V_t_ss,
           r,delta_p,delta_t,etaa,iotaa,epsilonn,f,lambda_p,zetaa,h_p,h_t,
           P_p_ss,P_t_ss,theta_p_ss,theta_t_ss,R_p_ss,R_t_ss,S_ss,q_p_ss,q_t_ss,phii_ss,
           J_p_s_ss,J_p_ns_ss,J_p0_ns_ss,J_t_ss,J_t_1_ss,W_p_s_ss,
           W_p_ns_ss,W_t_ss,U_ss,U_p_ss,U_t_ss,AA,
           w_p_s_ss,w_p_ns_ss,w_p0_ns_ss,w_t_ss,w_t_1_ss,u_p_ss,d_ss,u_t_ss,e_p_ss,e_t_ss,
           y_p_ss,y_t_ss,w_total_ss,w_total_p_ss,w_total_t_ss,
           x_p_s_ss,x_p_ns_ss,x_t_ss,alphaa;

%----------------------------------------------------------------
% 2. Parameters
%----------------------------------------------------------------
load 'cal_ss_master_t22_IRF.mat';

r = A1;
tau_p = A2;
tau_t = A3;
beta_p = A4;
beta_t = A5;
lambda_p = A6;
k_p = A7;
k_t = A8;
alphaa = A9;
gamma_p =A10;
gamma_t =A11;
z = A12;
etaa = A13;
delta_p = A14;
delta_t = A15;
iotaa = A16;
epsilonn = A17;
f = A18;
zetaa = A40;
h_p = A41;
h_t = A42;
AA = A19;

%----------------------------------------------------------------
% 3. Steady-State
%----------------------------------------------------------------
% The solutions of endogenous variables are given by "Code_calculation"

P_p_ss = A20;
P_t_ss = A21;
theta_p_ss = A22;
theta_t_ss = A23;
R_p_ss = A24;
R_t_ss = A25;
S_ss = A26;
q_p_ss = A27;
q_t_ss = A28;
u_p_ss = A29;
d_ss = A30;
u_t_ss = A31;
y_p_ss = A32;
y_t_ss = A33;
phii_ss = A34;
w_p_s_ss = A35;
w_p_ns_ss = A36;
w_p0_ns_ss = A37;
w_t_ss = A38;
w_t_1_ss = A39;
x_p_s_ss = 1/2*(R_p_ss+S_ss); 
x_p_ns_ss = 1/2*(1+S_ss);
x_t_ss = 1/2*(1+R_t_ss);

J_p_s_ss = (1-beta_p)*AA*P_p_ss*(x_p_s_ss-R_p_ss)*h_p/(r+delta_p+lambda_p*theta_p_ss*q_p_ss); //ok
J_p_ns_ss = (1-beta_p)/(r+delta_p)*AA*P_p_ss*h_p*(x_p_ns_ss-R_p_ss)+beta_p*(1-beta_p)/(r+delta_p)*(iotaa/beta_p-lambda_p*theta_p_ss*gamma_p/(1-beta_p)+lambda_p*theta_p_ss*q_p_ss/(1-beta_p)*f+lambda_p*theta_p_ss*q_p_ss/beta_p*epsilonn);//ok
J_p0_ns_ss = gamma_p/q_p_ss; //ok
J_t_ss = (1-beta_t)*AA*P_t_ss*h_t*(x_t_ss-R_t_ss)/(r+delta_t); //ok
J_t_1_ss = gamma_t/q_t_ss; //ok

V_p_ss=0;
V_t_ss=0;

U_p_ss = 1/r*z+theta_p_ss*gamma_p*beta_p/(r*(1-beta_p)); //ok
U_t_ss = 1/r*z+theta_t_ss*gamma_t*beta_t/(r*(1-beta_t));//ok
U_ss = U_t_ss;

W_p_s_ss = beta_p/(1-beta_p)*(J_p_s_ss+f)+U_ss;
W_p_ns_ss = beta_p/(1-beta_p)*(J_p_ns_ss+f)+U_ss;
W_t_ss = beta_t/(1-beta_t)*(J_t_ss)+U_ss;

e_p_ss = etaa-phii_ss-u_p_ss;
e_t_ss = phii_ss-u_t_ss;

w_total_p_ss =(w_p_s_ss*d_ss+w_p_ns_ss*(e_p_ss-d_ss-theta_p_ss*q_p_ss*(u_p_ss+lambda_p*d_ss))+w_p0_ns_ss*theta_p_ss*q_p_ss*(u_p_ss+lambda_p*d_ss))/e_p_ss ;
w_total_t_ss = (w_t_ss*(e_t_ss-theta_t_ss*q_t_ss*u_t_ss)+w_t_1_ss*theta_t_ss*q_t_ss*u_t_ss)/e_t_ss ;
w_total_ss = (h_p*w_total_p_ss*e_p_ss+h_t*w_total_t_ss*e_t_ss)/(h_p*e_p_ss+h_t*e_t_ss);

%----------------------------------------------------------------
% 4. The model
%----------------------------------------------------------------

external_function(name = equ1, nargs = 15);
external_function(name = equ2, nargs = 13);
external_function(name = equ3, nargs = 8);
external_function(name = equ4, nargs = 12);

model;
//production function
y_p = 1/2*A*((S+R_p)*d+(1+S)*(e_p-d)+(1-S)*theta_p*q_p*(u_p+lambda_p*d))*h_p; 
y_t = 1/2*A*((1+R_t)*e_t+(1-R_t)*theta_t*q_t*u_t)*h_t; 

//individual productivity (average)
x_p_s = 1/2*(R_p+S); 
x_p_ns = 1/2*(1+S);
x_t = 1/2*(1+R_t);

//Law of motion of labor flow
u_p-u_p(-1) = delta_p*R_p*e_p-theta_p*q_p*u_p; 
u_t-u_t(-1) = delta_t*R_t*e_t-theta_t*q_t*u_t; //Law of motion of unemployment of type T
d-d(-1) = delta_p*e_p*(S-R_p)-delta_p*d-lambda_p*theta_p*q_p*d; //Law of motion of job-to-job flow
e_p = etaa-phii-u_p;  //ok
e_t = phii-u_t;  //ok

//Price (solution of profit maximizing problem)
P_p = alphaa*zetaa*y_p^(alphaa*zetaa-1)*y_t^(zetaa*(1-alphaa)); //ok
P_t = (1-alphaa)*zetaa*y_p^(alphaa*zetaa)*y_t^(zetaa*(1-alphaa)-1); //ok

//Value of higing workers
(r+delta_p+lambda_p*theta_p*q_p)*J_p_s = A*P_p*x_p_s*h_p-w_p_s*h_p+equ1(R_p,beta_p,A,P_p,r,delta_p,lambda_p,theta_p,q_p,f,epsilonn,iotaa,z,gamma_p,h_p)-delta_p*R_p*f; //ok
(r+delta_p)*J_p_ns = A*P_p*x_p_ns*h_p-w_p_ns*h_p+equ1(R_p,beta_p,A,P_p,r,delta_p,lambda_p,theta_p,q_p,f,epsilonn,iotaa,z,gamma_p,h_p)-delta_p*R_p*f; //ok
(r+delta_t)*J_t = A*P_t*x_t*h_t-w_t*h_t+equ3(beta_t,P_t,R_t,A,z,theta_t,gamma_t,h_t); //ok

//Value of hiring new workers
r*V_p=-gamma_p+q_p*(J_p0_ns-V_p);
r*V_t=-gamma_t+q_t*(J_t_1-V_t);

// Value of being workers
(r+delta_p+lambda_p*theta_p*q_p)*W_p_s = w_p_s*h_p-iotaa+lambda_p*theta_p*q_p*((beta_p*(J_p0_ns)/(1-beta_p)+U)-epsilonn)+equ2(R_p,beta_p,P_p,r,delta_p,q_p,gamma_p,f,z,theta_p,A,U,h_p)+delta_p*R_p*U; //ok
(r+delta_p)*W_p_ns = w_p_ns*h_p+equ2(R_p,beta_p,P_p,r,delta_p,q_p,gamma_p,f,z,theta_p,A,U,h_p)+delta_p*R_p*U; //ok
(r+delta_t)*W_t = w_t*h_t+equ4(beta_t,P_t,R_t,r,delta_t,z,theta_t,gamma_t,A,q_t,U,h_t)+delta_t*R_t*U; //ok

//Value of unemployment
r*U_p=z+theta_p*q_p*beta_p/(1-beta_p)*(J_p0_ns-V_p);
r*U_t=z+theta_t*q_t*beta_t/(1-beta_t)*(J_t_1-V_t);
U=max(U_p,U_t);

//matching function
q_p = k_p*theta_p^(-tau_p); //ok
q_t = k_t*theta_t^(-tau_t); //ok

//wage
h_p*w_p_s  = beta_p*A*P_p*x_p_s*h_p+(1-beta_p)*(iotaa+z)+(1-lambda_p)*beta_p*theta_p*gamma_p+beta_p*(r+lambda_p*theta_p*q_p)*f+(1-beta_p)*lambda_p*theta_p*q_p*epsilonn;
h_p*w_p_ns = beta_p*A*P_p*x_p_ns*h_p+(1-beta_p)*z+beta_p*theta_p*gamma_p+beta_p*r*f;
h_p*w_p0_ns = beta_p*A*P_p*h_p+(1-beta_p)*z+beta_p*theta_p*gamma_p-beta_p*delta_p*f;
h_t*w_t = beta_t*A*P_t*x_t*h_t+(1-beta_t)*z+beta_t*theta_t*gamma_t;
h_t*w_t_1 = beta_t*A*P_t*h_t+(1-beta_t)*z+beta_t*theta_t*gamma_t;
w_total_p =(w_p_s*d+w_p_ns*(e_p-d-theta_p*q_p*(u_p+lambda_p*d))+w_p0_ns*theta_p*q_p*(u_p+lambda_p*d))/e_p ;
w_total_t = (w_t*(e_t-theta_t*q_t*u_t)+w_t_1*theta_t*q_t*u_t)/e_t ;
w_total = (h_p*w_total_p*e_p+h_t*w_total_t*e_t)/(h_p*e_p+h_t*e_t);

// Barganing
(1-beta_p)*(W_p_s-U) = beta_p*(J_p_s+f);
(1-beta_p)*(W_p_ns-U) = beta_p*(J_p_ns+f);
(1-beta_t)*(W_t-U) = beta_t*(J_t); 

//Pin down S, R_p, R_t and phii
1/2*(1-beta_p)*A*delta_p*P_p*h_p/(r+delta_p+lambda_p*theta_p*q_p)*(S-R_p)^2+1/2*((1-beta_p)*A*delta_p*P_p*h_p)/(r+delta_p)*(1-2*R_p-S^2+2*R_p*S)+beta_p*(1-beta_p)*delta_p/(r+delta_p)*(iotaa/beta_p-lambda_p*gamma_p*theta_p/(1-beta_p)+lambda_p*theta_p*q_p/(1-beta_p)*f+lambda_p*theta_p*q_p/beta_p*epsilonn)*(1-S)=equ1(R_p,beta_p,A,P_p,r,delta_p,lambda_p,theta_p,q_p,f,epsilonn,iotaa,z,gamma_p,h_p);//Job Destruction of P
1/2*(1-beta_t)*A*delta_t*P_t*h_t/(r+delta_t)*(1-R_t)^2 = equ3(beta_t,P_t,R_t,A,z,theta_t,gamma_t,h_t); //Job Destruction of T
A*P_p*(S-R_p)*h_p/(r+delta_p+lambda_p*theta_p*q_p)=beta_p/(1-beta_p)*(gamma_p/q_p-f)-iotaa/(lambda_p*theta_p*q_p)-epsilonn; //J_p_s(S)=J_p_ns(S)
theta_p*gamma_p=theta_t*gamma_t;
A*P_p*(1-S)*h_p/(r+delta_p)=gamma_p/q_p+iotaa/(lambda_p*theta_p*q_p)+epsilonn;

end;

%----------------------------------------------------------------
% 5. Computation
%----------------------------------------------------------------
initval;
P_p = P_p_ss;
P_t = P_t_ss;
theta_p = theta_p_ss;
theta_t = theta_t_ss;
R_p = R_p_ss;
R_t = R_t_ss;
S = S_ss;
q_p = q_p_ss;
q_t = q_t_ss;
J_p_s = J_p_s_ss;
J_p_ns = J_p_ns_ss;
J_p0_ns = J_p0_ns_ss;
J_t = J_t_ss;
J_t_1 = J_t_1_ss;
W_p_s = W_p_s_ss;
W_p_ns = W_p_ns_ss;
W_t = W_t_ss;
U_p = U_p_ss;
U_t = U_t_ss;
U = U_ss;
V_p=0;
V_t=0;
w_p_s = w_p_s_ss;
w_p_ns = w_p_ns_ss;
w_p0_ns = w_p0_ns_ss;
w_t = w_t_ss;
w_t_1 = w_t_1_ss;
u_p = u_p_ss;
d = d_ss;
u_t = u_t_ss;
e_p = e_p_ss;
e_t = e_t_ss;
y_p = y_p_ss;
y_t = y_t_ss;
w_total_p = w_total_p_ss;
w_total_t = w_total_t_ss;
w_total = w_total_ss;
x_p_s = x_p_s_ss;
x_p_ns = x_p_ns_ss;
x_t = x_t_ss;
phii = phii_ss;
A=1;
end;


resid;

steady;

xx=[1,1,0.9];

shocks;
var A;
periods 1:3;
values (xx);
end;

perfect_foresight_setup(periods=20); 
perfect_foresight_solver(lmmcp);
